#!/usr/bin/perl

# KNOWN BUGS:
# - This is only the cweb backend :)

# - Section level should be customizable
# - Language attribute is not checked (should be "C" or "C++")
# - #include line imm. followed by <ScrapUse> gets no \n separator
# - #line directives issued by cweb reference the .w, not the .ydslp

use SGMLS;                      # Use the SGMLS package.
use SGMLS::Output;              # Use stack-based output.

use SGMLS::ydSLitProg;
#use SGMLS::entities::general;

sgml ('<WEB>', "% generated by ydslp2fweb.pl\n");
sgml ('</WEB>', "\n@* \INDEX.\n");

sgml ('<LITSECT>', sub {
    my ($element,$event) = @_;

    LitSect->new($element);

    output "\n@* ";
});

sgml ('<SCRAP>', sub {
    my ($element,$event) = @_;

    Scrap->new($element);

    $sect = $element->in('LITSECT');

    $sect->inc_nBlurbs;
    if ($sect->get_nBlurbs > 1) {
	output ("\n@ ");
    } else {
	output "\n";
    }
});

sgml ('<FILE>', sub {
    my ($element,$event) = @_;
    my $name = $element->attribute('NAME')->value;

    my $scrap = $element->in('SCRAP');
    die "<File> outside of <Scrap>" unless $scrap;
    $scrap->set_file($name);

    if ($element->attribute('ISDEFAULT')->value eq 'DEFAULT') {
	output ("\n", '@a', "\n");
    } else {
	output ('@(', $name, '@>=', "\n");
    }
});

sgml ('<TITLE>', sub {
    my ($element,$event) = @_;
    my $parent = $element->parent;

    if ($parent->name eq 'SCRAP') {
	output ("@<");
    }
});

sgml ('</TITLE>', sub {
    my ($element,$event) = @_;
    my $parent = $element->parent;

    if ($parent->name eq 'LITSECT') {
	output (".\n");
    } elsif ($parent->name eq 'SCRAP') {
	output ("@>=\n");
    }
});

#  sub scrapuseInToplevelCode ($) {
#      my ($element) = @_;

#      my $scrap = $element->within('SCRAP');
#      die "<ScrapUse> outside of <Scrap>" unless $scrap;

#      return defined($scrap->get_file);
#  }

sgml ('<SCRAPUSE>', "@<");
sgml ('</SCRAPUSE>', sub {
    my ($element,$event) = @_;

    # FIXME: fweb can't resolve forward refs, whereas cweb can
    # I should probably expand it myself
    output "..." if ($element->attribute('ISABBREV')->value eq 'ABBREV');

#    if (scrapuseInToplevelCode($element)) {
	output ("@>@;");
#      } else {
#  	output ("@>;");
#      }
});

sgml ('<BLURB>', "\n");
sgml ('</BLURB>', "\n");

# common entities
sgml('|[lt    ]|', '<');
sgml('|[gt    ]|', '>');
sgml('|[amp   ]|', '&');

sgml('|[ndash ]|', '--');
sgml('|[mdash ]|', '---');
